/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package database;

import java.awt.Frame;
import java.sql.SQLException;
import javax.swing.JOptionPane;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableModel;
import javax.swing.tree.DefaultMutableTreeNode;

/**
 *
 * @author FuadRafid
 */
public class Officer extends javax.swing.JFrame implements TreeSelectionListener,TableModelListener{
        public static String reg_no;
        String selectedNow;
    /**
     * Creates new form Officer
     */
    public Officer() {
        initComponents();
        setExtendedState(java.awt.Frame.MAXIMIZED_BOTH);
        tree.removeAll();
        tree.addTreeSelectionListener(this);
        jTable1.getModel().addTableModelListener(this);
         DataBase.ExecuteQuery("Select name,gender,reg_no from OFF_EMP where ID='"+Login.ID+"'", Login.con);
        reg_no=DataBase.data.elementAt(0).elementAt(2);
        OffNameLabel.setText(DataBase.data.elementAt(0).elementAt(0));
         if(DataBase.data.elementAt(0).elementAt(1).toLowerCase().contains("female"))
        {
         jLabel1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/database/female.png")));
         
        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        tree = new javax.swing.JTree();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        OffNameLabel = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        jLabel0 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jButton1 = new javax.swing.JButton();
        logOutbtn = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        refresh = new javax.swing.JButton();
        jTextField1 = new javax.swing.JTextField();
        srch = new javax.swing.JButton();
        jComboBox1 = new javax.swing.JComboBox<>();
        jButton3 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setResizable(false);

        tree.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N
        javax.swing.tree.DefaultMutableTreeNode treeNode1 = new javax.swing.tree.DefaultMutableTreeNode("Data");
        javax.swing.tree.DefaultMutableTreeNode treeNode2 = new javax.swing.tree.DefaultMutableTreeNode("Expense");
        javax.swing.tree.DefaultMutableTreeNode treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("Maintainance");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("Books");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("Vehicle");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("Vehicle Components");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("Programs");
        treeNode2.add(treeNode3);
        treeNode1.add(treeNode2);
        treeNode2 = new javax.swing.tree.DefaultMutableTreeNode("Income");
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("Member Depositions");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("Donations");
        treeNode2.add(treeNode3);
        treeNode1.add(treeNode2);
        treeNode2 = new javax.swing.tree.DefaultMutableTreeNode("Central BookList");
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("All Books");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("Authors");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("Publishers");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("Suppliers");
        treeNode2.add(treeNode3);
        treeNode1.add(treeNode2);
        treeNode2 = new javax.swing.tree.DefaultMutableTreeNode("Vehicle Info");
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("Programs");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("Schedule");
        treeNode2.add(treeNode3);
        treeNode1.add(treeNode2);
        treeNode2 = new javax.swing.tree.DefaultMutableTreeNode("Job Applications");
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("Officer");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("Librarian");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("Driver");
        treeNode2.add(treeNode3);
        treeNode1.add(treeNode2);
        treeNode2 = new javax.swing.tree.DefaultMutableTreeNode("Members");
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("All Members");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("Vehicle Members");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("Book Requests");
        treeNode2.add(treeNode3);
        treeNode1.add(treeNode2);
        tree.setModel(new javax.swing.tree.DefaultTreeModel(treeNode1));
        jScrollPane1.setViewportView(tree);

        jTable1.setFont(new java.awt.Font("Arial Unicode MS", 0, 13)); // NOI18N
        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {},
                {},
                {},
                {}
            },
            new String [] {

            }
        ));
        jTable1.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_ALL_COLUMNS);
        jScrollPane2.setViewportView(jTable1);

        OffNameLabel.setFont(new java.awt.Font("Tahoma", 1, 18)); // NOI18N
        OffNameLabel.setText("jLabel3");

        jLabel1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/database/male.png"))); // NOI18N

        jLabel0.setFont(new java.awt.Font("Tahoma", 1, 18)); // NOI18N
        jLabel0.setText("WELCOME,");

        jLabel2.setIcon(new javax.swing.ImageIcon(getClass().getResource("/database/Bishwo-Shahitto-Kendro-logo1.png"))); // NOI18N

        jButton1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/database/tabadd.png"))); // NOI18N
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        logOutbtn.setFont(new java.awt.Font("Tahoma", 1, 18)); // NOI18N
        logOutbtn.setText("Log Out");
        logOutbtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                logOutbtnActionPerformed(evt);
            }
        });

        jButton2.setFont(new java.awt.Font("Tahoma", 1, 18)); // NOI18N
        jButton2.setText("Add Entry");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        refresh.setIcon(new javax.swing.ImageIcon(getClass().getResource("/database/reload-icon.png"))); // NOI18N
        refresh.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                refreshActionPerformed(evt);
            }
        });

        srch.setText("Search");
        srch.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                srchActionPerformed(evt);
            }
        });

        jButton3.setFont(new java.awt.Font("Tahoma", 1, 18)); // NOI18N
        jButton3.setText("Delete Entry");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(36, 36, 36)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel1)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addGap(18, 18, 18)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(layout.createSequentialGroup()
                                        .addGap(77, 77, 77)
                                        .addComponent(OffNameLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                                    .addGroup(layout.createSequentialGroup()
                                        .addComponent(jLabel0, javax.swing.GroupLayout.PREFERRED_SIZE, 157, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addGap(0, 0, Short.MAX_VALUE)))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel2))
                            .addGroup(layout.createSequentialGroup()
                                .addGap(547, 547, 547)
                                .addComponent(refresh, javax.swing.GroupLayout.PREFERRED_SIZE, 36, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(96, 96, 96)
                                .addComponent(jTextField1, javax.swing.GroupLayout.PREFERRED_SIZE, 237, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(18, 18, 18)
                                .addComponent(jComboBox1, javax.swing.GroupLayout.PREFERRED_SIZE, 126, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(175, 175, 175)
                                .addComponent(srch)
                                .addGap(0, 0, Short.MAX_VALUE))))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 261, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(125, 125, 125)
                                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 1132, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(0, 113, Short.MAX_VALUE))
                            .addGroup(layout.createSequentialGroup()
                                .addGap(0, 0, Short.MAX_VALUE)
                                .addComponent(jButton3)
                                .addGap(99, 99, 99)
                                .addComponent(jButton2, javax.swing.GroupLayout.PREFERRED_SIZE, 131, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(118, 118, 118)
                                .addComponent(jButton1)
                                .addGap(74, 74, 74)
                                .addComponent(logOutbtn, javax.swing.GroupLayout.PREFERRED_SIZE, 135, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addGap(39, 39, 39)))
                .addGap(43, 43, 43))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap(32, Short.MAX_VALUE)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 123, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGroup(layout.createSequentialGroup()
                                .addGap(31, 31, 31)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                    .addComponent(srch)
                                    .addGroup(layout.createSequentialGroup()
                                        .addComponent(jLabel0)
                                        .addGap(26, 26, 26)
                                        .addComponent(OffNameLabel)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                                .addComponent(jTextField1, javax.swing.GroupLayout.PREFERRED_SIZE, 33, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                .addComponent(jComboBox1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                            .addComponent(refresh, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))))))
                        .addGap(29, 29, 29))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(63, 63, 63)
                        .addComponent(jLabel2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 749, Short.MAX_VALUE)
                    .addComponent(jScrollPane1))
                .addGap(24, 24, 24)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(logOutbtn, javax.swing.GroupLayout.PREFERRED_SIZE, 53, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton1)
                    .addComponent(jButton2, javax.swing.GroupLayout.PREFERRED_SIZE, 59, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton3, javax.swing.GroupLayout.PREFERRED_SIZE, 59, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(40, 40, 40))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
         
          for(Frame f: Frame.getFrames()) 
        {
         if(f!=this)
             f.dispose();
        }
        Table_view extraData=new Table_view();
        
        if(selectedNow.equals("Authors"))
        {    try{
            
            
              
              
              extraData.book_author_view(jTable1.getModel().getValueAt(jTable1.getSelectedRow(),0).toString());
            
            
              if(DataBase.data.size()==0)
             {
               JOptionPane.showMessageDialog(null, "Author not verified");
               extraData.dispose();
               return;
             }
             extraData.setVisible(true);
              }
              catch(ArrayIndexOutOfBoundsException ex)
              {
                JOptionPane.showMessageDialog(null, "Select an author");
              }
             
            
        }
        if(selectedNow.equals("Publishers"))
        {
          extraData.setVisible(true);
          extraData.BOOK_PUBLISHER_VIEW(jTable1.getModel().getValueAt(jTable1.getSelectedRow(),0).toString());
        }
        if(selectedNow.equals("Suppliers"))
        {
          extraData.setVisible(true);
          extraData.BOOK_BOOKSTORE_VIEW(jTable1.getModel().getValueAt(jTable1.getSelectedRow(),0).toString());
        }
        if(selectedNow.equals("Cultural Programs"))
        {
          extraData.setVisible(true);
          extraData.PRIZE_WINNER_VIEW(jTable1.getModel().getValueAt(jTable1.getSelectedRow(),0).toString());
        }
       
    }//GEN-LAST:event_jButton1ActionPerformed

    private void logOutbtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_logOutbtnActionPerformed
        this.dispose();
        for(Frame f: Frame.getFrames()) 
        {
         f.dispose();
        }
        try {
            Login.con.close();
        } catch (SQLException ex) {
            System.out.println(ex);
        }
        new Login().setVisible(true);
      

    }//GEN-LAST:event_logOutbtnActionPerformed

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
         for(Frame f: Frame.getFrames()) 
        {
         if(f!=this)
             f.dispose();
        }
        if(selectedNow.equals("Maintainance")) 
        {
           MaintainanceEntry maint; 
            maint=new MaintainanceEntry();
            maint.setVisible(true);
        
        }
        else if(selectedNow.equals("Vehicle")) 
        { 
            
           EnterVehicle EntVeh;
           EntVeh= new EnterVehicle();
           EntVeh.setVisible(true);
        
        }
        else if(selectedNow.equals("CultProgExpense"))
        {
            EnterCultProg CultEnt;
            CultEnt=new EnterCultProg();
            CultEnt.setVisible(true);
        }
        else if(selectedNow.equals("All Books"))
        {
            BookEntry bookEnt=new BookEntry();
            bookEnt.setVisible(true);
        
        }
        else if(selectedNow.equals("Donations"))
        { 
            DonationEntry donEnt=new DonationEntry();
            donEnt.setVisible(true);
        
        }
        else if(selectedNow.equals("Vehicle Components"))   
        {
            ComponentEntry compEnt=new ComponentEntry();
            compEnt.setVisible(true);
        }
        else if(selectedNow.equals("Cultural Programs"))
        {
            AddPrizeWinner pz=new AddPrizeWinner();
           try{
            pz.Id=jTable1.getModel().getValueAt(jTable1.getSelectedRow(), 0).toString();
            System.out.println(pz.Id);
            pz.setVisible(true);
           }
           catch(Exception e)
           {
               JOptionPane.showMessageDialog(null, "Choose a program to add a prize winner");
               return;
           }
            
        }
        return;
        
    }//GEN-LAST:event_jButton2ActionPerformed

    private void refreshActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_refreshActionPerformed
        DefaultMutableTreeNode node = (DefaultMutableTreeNode)
                       tree.getLastSelectedPathComponent();

    if (node == null)
    //Nothing is selected.     
    return;
        Object nodeInfo = node.getUserObject();
    if (node.isLeaf()) {
         if(node.getUserObject().equals("Schedule"))
        {   
                selectedNow="Schedule";
                 DataBase.ExecuteQuery("Select SCHEDULE_NO,DAY,ARRIVAL_TIME,DEPARTURE_TIME,DIVISION,DISTRICT,POLICE_STATION,STREET from fuadrafid.schedule natural join fuadrafid.scheduling  where  reg_no='"+Officer.reg_no+"'", Login.con);
                Show_Users_In_JTable();
            
        }
         else if(node.getUserObject().equals("Maintainance"))
        {   
                selectedNow="Maintainance";
                DataBase.ExecuteQuery("Select * from vehicle_maintainance",  Login.con);
                Show_Users_In_JTable();
            
        }
        else if(node.getUserObject().equals("Vehicle"))
        {   
                selectedNow="Vehicle";
                DataBase.ExecuteQuery("Select * from new_vehicle",  Login.con);
                Show_Users_In_JTable();
            
        }
        else if(node.getUserObject().equals("Vehicle Components"))
        {     
                selectedNow="Vehicle Components";
                DataBase.ExecuteQuery("Select * from NEW_COMPONENT",  Login.con);
                Show_Users_In_JTable();
           
        }
        else if(node.getUserObject().equals("Books"))
        {   
                selectedNow="Books";
                DataBase.ExecuteQuery("select * from book_spend_money",  Login.con);
                Show_Users_In_JTable();
          
        }
        else if(node.getUserObject().equals("Member Depositions"))
        {   
                selectedNow="Member Depositions";
                DataBase.ExecuteQuery("select \"SERIAL NO\", \"AMOUNT\", \"TRANSAC DATE\", \"MEMBER NAME\" from mem_dep where reg='"+reg_no+"'",  Login.con);
                Show_Users_In_JTable();
          
        }
        else if(node.getUserObject().equals("Donations"))
        {   
                selectedNow="Donations";
                DataBase.ExecuteQuery("select * from donations_given",  Login.con);
                Show_Users_In_JTable();
          
        }
       
        else if(node.getUserObject().equals("All Books"))
        {   
                selectedNow="All Books";
                DataBase.ExecuteQuery("select * from book_list_view",  Login.con);
                Show_Users_In_JTable();
        }
        else if(node.getUserObject().equals("Authors"))
        {
            selectedNow="Authors";
            DataBase.ExecuteQuery("select author_id,name,writing_Category from fuadrafid.AUTHOR natural join fuadrafid.WRITTEN_BY NATURAL JOIN fuadrafid.BOOKS WHERE AVAILABILITY='1'; ",  Login.con);
            Show_Users_In_JTable();
            
        }
        else if(node.getUserObject().equals("Publishers"))
        {
            selectedNow="Publishers";
            DataBase.ExecuteQuery("select * from fuadrafid.Publisher",  Login.con);
            Show_Users_In_JTable();
            
        }
        else if(node.getUserObject().equals("Suppliers"))
        {
            selectedNow="Suppliers";
            DataBase.ExecuteQuery("select * from fuadrafid.book_store",  Login.con);
            Show_Users_In_JTable();
        }
        else if(node.getUserObject().equals("Officer"))
        {
            selectedNow="Officer";
            DataBase.ExecuteQuery("select \"Applicantion No\",\"Applicant Name\",\"Email\", \"Contact No.\",\"Gender\", \"Exam Result\", \"Computer Skills\", \"Previous Experiences\" from OFFICER_APPLICANTS_VIEW "
                    + "where \"Employee In Charge\"='"+Login.ID+"'",  Login.con);
            Show_Users_In_JTable();
        }
        else if(node.getUserObject().equals("Librarian"))
        {
            selectedNow="Librarian";
            DataBase.ExecuteQuery("select \"Applicantion No\",\"Applicant Name\",\"Email\", \"Contact No.\",\"Gender\", \"Exam Result\", \"Specialization\", \"Previous Experiences\" from librarian_applicants_view "
                    + "where \"Employee In Charge\"='"+Login.ID+"'",  Login.con);
            Show_Users_In_JTable();
        }
        else if(node.getUserObject().equals("Driver"))
        {
            selectedNow="Driver";
            DataBase.ExecuteQuery("select \"Applicantion No\",\"Applicant Name\",\"Email\", \"Contact No.\",\"Gender\", \"License No.\", \"Police Record\", \"Previous Experiences\" from DRIVER_APPLICANTS_VIEW "
                    + "where \"Employee In Charge\"='"+Login.ID+"'",  Login.con);
            Show_Users_In_JTable();
        }
        else if(node.getUserObject().equals("Programs"))
        {
            selectedNow="Cultural Programs";
            if(node.getParent().toString().equals("Vehicle Info"))
            {
            DataBase.ExecuteQuery("select \"Program ID\",\"Program\",\"Location\",\"Date\" from cultural_prog_view "
                    + "where \"Employee In Charge\"='"+Login.ID+"'",  Login.con);
            Show_Users_In_JTable();
            }
            else if(node.getParent().toString().equals("Expense"))
            {
            selectedNow="CultProgExpense";
            DataBase.ExecuteQuery("select \"RECEIPT NO\", \"AMOUNT\", \"EXPENSE_DATE\", \"PROG NO\", \"LOCATION\", \"PROG DATE\", \"DESCRIPTION\" from CULTURAL_PROGRAM_EXPENSE "
                    + "where \"ARRANGED BY\"='"+Login.ID+"'",  Login.con);
            Show_Users_In_JTable();
            }
            
        }
        else if(node.getUserObject().equals("Book Requests"))
        {   
                selectedNow="Book Requests";
                DataBase.ExecuteQuery("SELECT \"BOOK\", \"AUTHOR\", \"EDITION\" from OFFICER_BOOK_REQS "
                + " WHERE \"REG NO\"='"+Officer.reg_no+"'",Login.con);
        Show_Users_In_JTable();
                Show_Users_In_JTable();
            
        }
        else if(node.getUserObject().equals("Vehicle Members"))
        {   
                selectedNow="Show Members";
                 DataBase.ExecuteQuery("Select ID,NAME,CONTACT_NO,EMAIL_ADDRESS,GENDER,JOINING_DATE,MEMBERSHIP_TYPE from vehicle_members where lib_id='"+Login.ID+"' order by NAME", Login.con);
                Show_Users_In_JTable();
            
        }
        else if(node.getUserObject().equals("All Members"))
        {   
                selectedNow="All Members";
                 DataBase.ExecuteQuery("Select * from fuadrafid.members", Login.con);
                Show_Users_In_JTable();
            
        }
       
    } 
    }//GEN-LAST:event_refreshActionPerformed

    private void srchActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_srchActionPerformed
          DefaultMutableTreeNode node = (DefaultMutableTreeNode)
                       tree.getLastSelectedPathComponent();

    if (node == null)
    //Nothing is selected.     
    return;
        Object nodeInfo = node.getUserObject();
    if (node.isLeaf()) {
        if(node.getUserObject().equals("Schedule"))
        {   
                selectedNow="Schedule";
                 DataBase.ExecuteQuery("Select SCHEDULE_NO,DAY,ARRIVAL_TIME,DEPARTURE_TIME,DIVISION,DISTRICT,POLICE_STATION,STREET from fuadrafid.schedule natural join fuadrafid.scheduling  where  reg_no='"+Officer.reg_no+"' and lower(\""+jComboBox1.getSelectedItem()+"\") LIKE '%"+jTextField1.getText().toLowerCase()+"%'",  Login.con);
                Show_Users_In_JTable();
            
        }
        else if(node.getUserObject().equals("Maintainance"))
        {   
                selectedNow="Maintainance";
                DataBase.ExecuteQuery("Select * from vehicle_maintainance where lower(\""+jComboBox1.getSelectedItem()+"\") LIKE '%"+jTextField1.getText().toLowerCase()+"%'",  Login.con);
                Show_Users_In_JTable();
            
        }
        if(node.getUserObject().equals("Vehicle"))
        {   
                selectedNow="Vehicle";
                DataBase.ExecuteQuery("Select * from new_vehicle where lower(\""+jComboBox1.getSelectedItem()+"\") LIKE '%"+jTextField1.getText().toLowerCase()+"%'",  Login.con);
                Show_Users_In_JTable();
            
        }
         if(node.getUserObject().equals("Vehicle Components"))
        {     
                selectedNow="Vehicle Components";
                DataBase.ExecuteQuery("Select * from NEW_COMPONENT where lower(\""+jComboBox1.getSelectedItem()+"\") LIKE '%"+jTextField1.getText().toLowerCase()+"%'",  Login.con);
                Show_Users_In_JTable();
           
        }
        if(node.getUserObject().equals("Books"))
        {   
                selectedNow="Books";
                DataBase.ExecuteQuery("select * from book_spend_money where lower(\""+jComboBox1.getSelectedItem()+"\") LIKE '%"+jTextField1.getText().toLowerCase()+"%'",  Login.con);
                Show_Users_In_JTable();
          
        }
        if(node.getUserObject().equals("Member Depositions"))
        {   
                selectedNow="Member Depositions";
                DataBase.ExecuteQuery("select \"SERIAL_NO\", \"AMOUNT\", \"TRANSAC DATE\", \"MEMBER NAME\" from mem_dep where reg='"+reg_no+"' and lower(\""+jComboBox1.getSelectedItem()+"\") LIKE '%"+jTextField1.getText().toLowerCase()+"%'",  Login.con);
                Show_Users_In_JTable();
          
        }
        if(node.getUserObject().equals("Donations"))
        {   
                selectedNow="Donations";
                DataBase.ExecuteQuery("select * from donations_given where lower(\""+jComboBox1.getSelectedItem()+"\") LIKE '%"+jTextField1.getText().toLowerCase()+"%'",  Login.con);
                Show_Users_In_JTable();
          
        }
       
        if(node.getUserObject().equals("All Books"))
        {   
                selectedNow="All Books";
                DataBase.ExecuteQuery("select * from book_list_view where lower(\""+jComboBox1.getSelectedItem()+"\") LIKE '%"+jTextField1.getText().toLowerCase()+"%'",  Login.con);
                Show_Users_In_JTable();
        }
        if(node.getUserObject().equals("Authors"))
        {
            selectedNow="Authors";
            DataBase.ExecuteQuery("select author_id,name,writing_Category from fuadrafid.AUTHOR natural join fuadrafid.WRITTEN_BY NATURAL JOIN fuadrafid.BOOKS WHERE AVAILABILITY='1' and lower(\""+jComboBox1.getSelectedItem()+"\") LIKE '%"+jTextField1.getText().toLowerCase()+"%'",  Login.con);
            Show_Users_In_JTable();
            
        }
        if(node.getUserObject().equals("Publishers"))
        {
            selectedNow="Publishers";
            DataBase.ExecuteQuery("select * from fuadrafid.Publisher where lower(\""+jComboBox1.getSelectedItem()+"\") LIKE '%"+jTextField1.getText().toLowerCase()+"%'",  Login.con);
            Show_Users_In_JTable();
            
        }
        if(node.getUserObject().equals("Suppliers"))
        {
            selectedNow="Suppliers";
            DataBase.ExecuteQuery("select * from fuadrafid.book_store where lower(\""+jComboBox1.getSelectedItem()+"\") LIKE '%"+jTextField1.getText().toLowerCase()+"%'",  Login.con);
            Show_Users_In_JTable();
        }
        if(node.getUserObject().equals("Officer"))
        {
            selectedNow="Officer";
            DataBase.ExecuteQuery("select \"Applicantion No\",\"Applicant Name\",\"Email\", \"Contact No.\",\"Gender\", \"Exam Result\", \"Computer Skills\", \"Previous Experiences\" from OFFICER_APPLICANTS_VIEW "
                    + "where \"Employee In Charge\"='"+Login.ID+"' AND lower(\""+jComboBox1.getSelectedItem()+"\") LIKE '%"+jTextField1.getText().toLowerCase()+"%'",  Login.con);
            Show_Users_In_JTable();
        }
        if(node.getUserObject().equals("Librarian"))
        {
            selectedNow="Librarian";
            DataBase.ExecuteQuery("select \"Applicantion No\",\"Applicant Name\",\"Email\", \"Contact No.\",\"Gender\", \"Exam Result\", \"Specialization\", \"Previous Experiences\" from librarian_applicants_view "
                    + "where \"Employee In Charge\"='"+Login.ID+"' AND lower(\""+jComboBox1.getSelectedItem()+"\") LIKE '%"+jTextField1.getText().toLowerCase()+"%'",  Login.con);
            Show_Users_In_JTable();
        }
         if(node.getUserObject().equals("Driver"))
        {
            selectedNow="Driver";
            DataBase.ExecuteQuery("select \"Applicantion No\",\"Applicant Name\",\"Email\", \"Contact No.\",\"Gender\", \"License No.\", \"Police Record\", \"Previous Experiences\" from DRIVER_APPLICANTS_VIEW "
                    + "where \"Employee In Charge\"='"+Login.ID+"' AND lower(\""+jComboBox1.getSelectedItem()+"\") LIKE '%"+jTextField1.getText().toLowerCase()+"%'",  Login.con);
            Show_Users_In_JTable();
        }
          if(node.getUserObject().equals("Programs"))
        {
            selectedNow="Cultural Programs";
            if(node.getParent().toString().equals("Vehicle Info"))
            {
            DataBase.ExecuteQuery("select \"Program ID\",\"Program\",\"Location\",\"Date\" from cultural_prog_view "
                    + "where \"Employee In Charge\"='"+Login.ID+"' AND lower(\""+jComboBox1.getSelectedItem()+"\") LIKE '%"+jTextField1.getText().toLowerCase()+"%'",  Login.con);
            Show_Users_In_JTable();
            }
            if(node.getParent().toString().equals("Expense"))
            {
            selectedNow="CultProgExpense";
            DataBase.ExecuteQuery("select \"RECEIPT NO\", \"AMOUNT\", \"EXPENSE_DATE\", \"PROG NO\", \"LOCATION\", \"PROG DATE\", \"DESCRIPTION\" from CULTURAL_PROGRAM_EXPENSE "
                    + "where \"ARRANGED BY\"='"+Login.ID+"' AND lower(\""+jComboBox1.getSelectedItem()+"\") LIKE '%"+jTextField1.getText().toLowerCase()+"%'",  Login.con);
            Show_Users_In_JTable();
            }
            
        }
        if(node.getUserObject().equals("Book Requests"))
        {   
                selectedNow="Book Requests";
                DataBase.ExecuteQuery("SELECT \"BOOK\", \"AUTHOR\", \"EDITION\" from OFFICER_BOOK_REQS "
                + " WHERE \"REG NO\"='"+Officer.reg_no+"' AND lower(\""+jComboBox1.getSelectedItem()+"\") LIKE '%"+jTextField1.getText().toLowerCase()+"%'",  Login.con);
        Show_Users_In_JTable();
                Show_Users_In_JTable();
            
        }
        if(node.getUserObject().equals("Vehicle Members"))
        {   
                selectedNow="Show Members";
                 DataBase.ExecuteQuery("Select ID,NAME,CONTACT_NO,EMAIL_ADDRESS,GENDER,JOINING_DATE,MEMBERSHIP_TYPE from vehicle_members where lib_id='"+Login.ID+"' AND lower(\""+jComboBox1.getSelectedItem()+"\") LIKE '%"+jTextField1.getText().toLowerCase()+"%' order by NAME",  Login.con);
                Show_Users_In_JTable();
            
        }
        if(node.getUserObject().equals("All Members"))
        {   
                selectedNow="All Members";
                 DataBase.ExecuteQuery("Select * from fuadrafid.members WHERE lower(lower(\""+jComboBox1.getSelectedItem()+"\")) LIKE '%"+jTextField1.getText().toLowerCase().toLowerCase()+"%'",  Login.con);
                Show_Users_In_JTable();
            
        }
       
    } 
    }//GEN-LAST:event_srchActionPerformed

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
      if(selectedNow.equals("Officer"))
      {
          System.out.println(jTable1.getModel().getValueAt(jTable1.getSelectedRow(),0));
          DataBase.ExecuteQuery("Delete from fuadrafid.job_applicants where application_no='"+jTable1.getModel().getValueAt(jTable1.getSelectedRow(),0)+"'", Login.con);
          refresh.doClick();
         
      }
      else if(selectedNow.equals("Librarian"))
      {
          System.out.println(jTable1.getModel().getValueAt(jTable1.getSelectedRow(),0));
          DataBase.ExecuteQuery("Delete from fuadrafid.job_applicants where application_no='"+jTable1.getModel().getValueAt(jTable1.getSelectedRow(),0)+"'", Login.con);
          refresh.doClick();
          
      }
      else if(selectedNow.equals("Driver"))
      {
          System.out.println(jTable1.getModel().getValueAt(jTable1.getSelectedRow(),0));
          DataBase.ExecuteQuery("Delete from fuadrafid.job_applicants where application_no='"+jTable1.getModel().getValueAt(jTable1.getSelectedRow(),0)+"'", Login.con);
          refresh.doClick();
      }
      else if(selectedNow.equals("All Members"))
        {
            String username;
            DataBase.ExecuteQuery("Delete from fuadrafid.members where member_id='"+jTable1.getModel().getValueAt(jTable1.getSelectedRow(),0)+"'", Login.con);
            DataBase.ExecuteQuery("Select username from fuadrafid.login_members where member_id='"+jTable1.getModel().getValueAt(jTable1.getSelectedRow(),0)+"'", Login.con);
            username=DataBase.data.elementAt(0).elementAt(0);
            DataBase.ExecuteQuery("Drop user "+username, Login.con);
            DataBase.ExecuteQuery("Delete from fuadrafid.login_members where member_id='"+jTable1.getModel().getValueAt(jTable1.getSelectedRow(),0)+"'", Login.con);
            refresh.doClick();
        }
      else
      {
          JOptionPane.showMessageDialog(null, "Cannot be deleted");
          return;
      }
        JOptionPane.showMessageDialog(null, "Successfully deleted");
    }//GEN-LAST:event_jButton3ActionPerformed

    /**
     * @param args the command line arguments
     */


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel OffNameLabel;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JComboBox<String> jComboBox1;
    private javax.swing.JLabel jLabel0;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTable jTable1;
    private javax.swing.JTextField jTextField1;
    private javax.swing.JButton logOutbtn;
    public static javax.swing.JButton refresh;
    private javax.swing.JButton srch;
    private javax.swing.JTree tree;
    // End of variables declaration//GEN-END:variables

    @Override
    public void valueChanged(TreeSelectionEvent e) {
       DefaultMutableTreeNode node = (DefaultMutableTreeNode)
                       tree.getLastSelectedPathComponent();

    if (node == null)
    //Nothing is selected.     
    return;

    Object nodeInfo = node.getUserObject();
    if (node.isLeaf()) {
        if(node.getUserObject().equals("Schedule"))
        {   
                selectedNow="Schedule";
                 DataBase.ExecuteQuery("Select SCHEDULE_NO,DAY,ARRIVAL_TIME,DEPARTURE_TIME,DIVISION,DISTRICT,POLICE_STATION,STREET from fuadrafid.schedule natural join fuadrafid.scheduling  where  reg_no='"+Officer.reg_no+"'", Login.con);
                Show_Users_In_JTable();
            
        }
        else if(node.getUserObject().equals("Maintainance"))
        {   
                selectedNow="Maintainance";
                DataBase.ExecuteQuery("Select * from vehicle_maintainance",  Login.con);
                Show_Users_In_JTable();
            
        }
        else if(node.getUserObject().equals("Vehicle"))
        {   
                selectedNow="Vehicle";
                DataBase.ExecuteQuery("Select * from new_vehicle",  Login.con);
                Show_Users_In_JTable();
            
        }
        else if(node.getUserObject().equals("Vehicle Components"))
        {     
                selectedNow="Vehicle Components";
                DataBase.ExecuteQuery("Select * from NEW_COMPONENT",  Login.con);
                Show_Users_In_JTable();
           
        }
        else if(node.getUserObject().equals("Books"))
        {   
                selectedNow="Books";
                DataBase.ExecuteQuery("select * from book_spend_money",  Login.con);
                Show_Users_In_JTable();
          
        }
        else if(node.getUserObject().equals("Member Depositions"))
        {   
                selectedNow="Member Depositions";
                DataBase.ExecuteQuery("select \"SERIAL NO\", \"AMOUNT\", \"TRANSAC DATE\", \"MEMBER NAME\" from mem_dep where reg='"+reg_no+"'",  Login.con);
                Show_Users_In_JTable();
          
        }
        else if(node.getUserObject().equals("Donations"))
        {   
                selectedNow="Donations";
                DataBase.ExecuteQuery("select * from donations_given",  Login.con);
                Show_Users_In_JTable();
          
        }
       
        else if(node.getUserObject().equals("All Books"))
        {   
                selectedNow="All Books";
                DataBase.ExecuteQuery("select * from book_list_view",  Login.con);
                Show_Users_In_JTable();
        }
        else if(node.getUserObject().equals("Authors"))
        {
            selectedNow="Authors";
            DataBase.ExecuteQuery("select author_id,name,writing_Category from fuadrafid.AUTHOR natural join fuadrafid.WRITTEN_BY NATURAL JOIN fuadrafid.BOOKS WHERE AVAILABILITY='1'",  Login.con);
            Show_Users_In_JTable();
            
        }
        else if(node.getUserObject().equals("Publishers"))
        {
            selectedNow="Publishers";
            DataBase.ExecuteQuery("select * from fuadrafid.Publisher",  Login.con);
            Show_Users_In_JTable();
            
        }
        else if(node.getUserObject().equals("Suppliers"))
        {
            selectedNow="Suppliers";
            DataBase.ExecuteQuery("select * from fuadrafid.book_store",  Login.con);
            Show_Users_In_JTable();
        }
        else if(node.getUserObject().equals("Officer"))
        {
            selectedNow="Officer";
            DataBase.ExecuteQuery("select \"Applicantion No\",\"Applicant Name\",\"Email\", \"Contact No.\",\"Gender\", \"Exam Result\", \"Computer Skills\", \"Previous Experiences\" from OFFICER_APPLICANTS_VIEW "
                    + "where \"Employee In Charge\"='"+Login.ID+"'",  Login.con);
            Show_Users_In_JTable();
        }
        else if(node.getUserObject().equals("Librarian"))
        {
            selectedNow="Librarian";
            DataBase.ExecuteQuery("select \"Applicantion No\",\"Applicant Name\",\"Email\", \"Contact No.\",\"Gender\", \"Exam Result\", \"Specialization\", \"Previous Experiences\" from librarian_applicants_view "
                    + "where \"Employee In Charge\"='"+Login.ID+"'",  Login.con);
            Show_Users_In_JTable();
        }
        else if(node.getUserObject().equals("Driver"))
        {
            selectedNow="Driver";
            DataBase.ExecuteQuery("select \"Applicantion No\",\"Applicant Name\",\"Email\", \"Contact No.\",\"Gender\", \"License No.\", \"Police Record\", \"Previous Experiences\" from DRIVER_APPLICANTS_VIEW "
                    + "where \"Employee In Charge\"='"+Login.ID+"'",  Login.con);
            Show_Users_In_JTable();
        }
        else  if(node.getUserObject().equals("Programs"))
        {
            selectedNow="Cultural Programs";
            if(node.getParent().toString().equals("Vehicle Info"))
            {
            DataBase.ExecuteQuery("select \"Program ID\",\"Program\",\"Location\",\"Date\" from cultural_prog_view "
                    + "where \"Employee In Charge\"='"+Login.ID+"'",  Login.con);
            Show_Users_In_JTable();
            }
            if(node.getParent().toString().equals("Expense"))
            {
            selectedNow="CultProgExpense";
            DataBase.ExecuteQuery("select \"RECEIPT NO\", \"AMOUNT\", \"EXPENSE_DATE\", \"PROG NO\", \"LOCATION\", \"PROG DATE\", \"DESCRIPTION\" from CULTURAL_PROGRAM_EXPENSE "
                    + "where \"ARRANGED BY\"='"+Login.ID+"'",  Login.con);
            Show_Users_In_JTable();
            }
            
        }
         else if(node.getUserObject().equals("Book Requests"))
        {   
                selectedNow="Show Members";
                DataBase.ExecuteQuery("SELECT \"BOOK\", \"AUTHOR\", \"EDITION\" from OFFICER_BOOK_REQS "
                + " WHERE \"REG NO\"='"+Officer.reg_no+"'",Login.con);
        Show_Users_In_JTable();
                Show_Users_In_JTable();
            
        }
        else if(node.getUserObject().equals("Vehicle Members"))
        {   
                selectedNow="Show Members";
                 DataBase.ExecuteQuery("Select ID,NAME,CONTACT_NO,EMAIL_ADDRESS,GENDER,JOINING_DATE,MEMBERSHIP_TYPE from vehicle_members where lib_id='"+Login.ID+"' order by NAME", Login.con);
                Show_Users_In_JTable();
            
        }
        else if(node.getUserObject().equals("All Members"))
        {   
                selectedNow="All Members";
                 DataBase.ExecuteQuery("Select * from fuadrafid.members", Login.con);
                Show_Users_In_JTable();
            
        }
        jComboBox1.removeAllItems();
        for (int i = 0; i < DataBase.TableHeader.size(); i++) {
             jComboBox1.addItem(DataBase.TableHeader.elementAt(i));
        }
       
       
    } 
   
    }
    
     public void Show_Users_In_JTable()
   {
       
       
      DefaultTableModel model = (DefaultTableModel)jTable1.getModel();
      model.setRowCount(0);
      model.setColumnCount(0);
      for (int i = 0; i < DataBase.TableHeader.size(); i++) 
       {
           model.addColumn(DataBase.TableHeader.elementAt(i));
       }
       for(int i = 0; i < DataBase.data.size(); i++)
       {     
           model.addRow(DataBase.data.elementAt(i));
           
       }

     TableColumnAdjuster ad=new TableColumnAdjuster(jTable1);
     ad.adjustColumns();   
     
   }

    @Override
    public void tableChanged(TableModelEvent e) {
        String data=null;
        String Pk=null;
        String columnName=null;
        try{
        int row = e.getFirstRow();
        int column = e.getColumn();
        TableModel model = (TableModel)e.getSource();
         columnName= model.getColumnName(column);
         data=(String) model.getValueAt(row, column);
         Pk=(String) model.getValueAt(row, 0);
        System.out.println(data);
        }
        catch(Exception ex){}
        if(selectedNow=="Officer"||selectedNow=="Librarian")
        {
           if(columnName.equals("Exam Result"))
           {
               DataBase.ExecuteQuery("Update fuadrafid."+selectedNow+"_applicants set exam_result='"+data+"' where application_no='"+Pk+"'", Login.con);
               refresh.doClick();
           }
        }
        else if(selectedNow=="All Members")
        {
           
           if(columnName.equals("MEMBER_ID" ) || data==null)
              return;
            DataBase.ExecuteQuery("Update fuadrafid.members set "+columnName+"='"+data+"' where MEMBER_ID='"+Pk+"'", Login.con);
            refresh.doClick();
           
        }
        else if(selectedNow=="Schedule")
        {
           
           if(columnName.equals("Schedule_no" ) || data==null)
              return;
            DataBase.ExecuteQuery("Update fuadrafid.schedule set "+columnName+"='"+data+"' where Schedule_no='"+Pk+"'", Login.con);
            refresh.doClick();
           
        }
        
    }
     
    
}
